// OleAccTestDlg.cpp : implementation file
//

#include "stdafx.h"
#include "OleAccTest.h"
#include "OleAccTestDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif


// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	enum { IDD = IDD_ABOUTBOX };

	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support

// Implementation
protected:
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
END_MESSAGE_MAP()


// COleAccTestDlg dialog




COleAccTestDlg::COleAccTestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(COleAccTestDlg::IDD, pParent)
	, m_hwnd_text(_T("0x00410450"))  // XXX
	, m_output(_T(""))
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void COleAccTestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT1, m_hwnd_text);
	DDX_Text(pDX, IDC_EDIT2, m_output);
}

BEGIN_MESSAGE_MAP(COleAccTestDlg, CDialog)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDOK, &COleAccTestDlg::OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, &COleAccTestDlg::OnBnClickedCancel)
END_MESSAGE_MAP()


// COleAccTestDlg message handlers

BOOL COleAccTestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void COleAccTestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void COleAccTestDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR COleAccTestDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


#include <mshtml.h>
#include <atlbase.h>
#include <oleacc.h>
#include <Tlhelp32.h>
#include "interfaces/mozilla/ISimpleDOMDocument.h"
#include "interfaces/webkit/DOMHTML.h"


LPFNOBJECTFROMLRESULT pfObjectFromLresult = NULL;

BOOL CALLBACK EnumChildProc(HWND hwnd, LPARAM lParam)
{
	WCHAR buf[100];
	BSTR url=NULL, doctype=NULL, title=NULL;
	HRESULT hr;
	COleAccTestDlg *gui = (COleAccTestDlg *)lParam;

	GetClassNameW( hwnd, (LPWSTR)&buf, sizeof(buf)/sizeof(buf[0]) );

	gui->oprintf(L"Window Child found: %s", buf);

	/************************************************************************/
	/*  MICROSOFT INTERNET EXPLORER                                         */
	/************************************************************************/
	if ( wcscmp( buf, L"Internet Explorer_Server" ) == 0) {
		IHTMLDocument2 *spDoc;
		LRESULT lRes;
		UINT nMsg;
		
		if ( !pfObjectFromLresult )
			return FALSE;

		nMsg = RegisterWindowMessageW( L"WM_HTML_GETOBJECT" );
		if ( !SendMessageTimeoutW( hwnd, nMsg, 0L, 0L, SMTO_ABORTIFHUNG, 1000, (DWORD*)&lRes ) )
			return FALSE;

		hr = (*pfObjectFromLresult)( lRes, IID_IHTMLDocument2, 0, reinterpret_cast<LPVOID *>(&spDoc) );
		if ( SUCCEEDED(hr) ) {
			spDoc->get_URL(&url);
			// XXX Logga su file (CHECK SE URL != NULL)
			gui->oprintf(L"IExplorer URL: %s", url);
			SysFreeString(url);
			spDoc->Release();		
		}
		return FALSE;

	/************************************************************************/
	/*  MOZILLA FIREFOX                                                     */
	/************************************************************************/
	} else if ( wcscmp( buf, L"MozillaWindowClass" ) == 0 ) {
		IAccessible *pAccessible = NULL; 
		IServiceProvider *pServProv = NULL; 
		ISimpleDOMDocument *pSimpleDOMDocument;  // this is Mozilla specific
		BOOL ret_val = TRUE;
			
		hr = AccessibleObjectFromWindow(hwnd, OBJID_CLIENT, IID_IAccessible,(void**)&pAccessible); 
		if (SUCCEEDED(hr) && pAccessible != NULL) { 
			pAccessible->QueryInterface(IID_IServiceProvider,(void**)&pServProv); 
			if (pServProv) { 
				// sApplicationObject Service
				// see this:
				// http://msdn.microsoft.com/en-us/library/microsoft.visualstudio.shell.interop.sapplicationobject.aspx
				const GUID refguid = {0x0c539790, 0x12e4, 0x11cf, 0xb6, 0x61, 0x00, 0xaa, 0x00, 0x4c, 0xd6, 0xd8}; 
				hr = pServProv->QueryService(refguid, IID_ISimpleDOMDocument, (void**)&pSimpleDOMDocument); 
				if (SUCCEEDED(hr) && pSimpleDOMDocument != NULL) { 
					pSimpleDOMDocument->get_URL(&url);
					pSimpleDOMDocument->get_docType(&doctype);
					pSimpleDOMDocument->get_title(&title);
					if (!doctype || wcscmp(doctype, L"window")) {
						// XXX Logga su file (CHECK SE URL != NULL)
						gui->oprintf(L"Firefox URL: %s [%s]", title, url);
						ret_val = FALSE;
					}
					SysFreeString(title);
					SysFreeString(doctype);
					SysFreeString(url);
					pSimpleDOMDocument->Release();
				} 
				pServProv->Release();
			}   
			pAccessible->Release();
		} 
		return ret_val;

	/************************************************************************/
	/* APPLE SAFARI                                                         */
	/************************************************************************/
	} else if ( wcscmp( buf, L"URLEdit" ) == 0 || wcscmp( buf, L"WebKitEdit" ) == 0 ) {
		IAccessible *iAcc = NULL; 

		hr = AccessibleObjectFromWindow(hwnd, OBJID_WINDOW, IID_IAccessible,(void**)&iAcc); 
		if (SUCCEEDED(hr) && iAcc != NULL) { 

			gui->OleWalk(iAcc, 0);

			iAcc->Release();

			return TRUE;
		} else {
			gui->oprintf(L"ERROR AccessibleObjectFromWindow %d", hr);
		}

#if 0		
		IAccessible *pAccessible = NULL; 
		IServiceProvider *pServProv = NULL; 
		IDOMHTMLDocument *pDOMHTMLDocument;  
		BOOL ret_val = TRUE;

		gui->oprintf(L"safari: %s", buf);

		hr = AccessibleObjectFromWindow(hwnd, OBJID_CLIENT, IID_IAccessible,(void**)&pAccessible); 
		if (SUCCEEDED(hr) && pAccessible != NULL) { 
			pAccessible->QueryInterface(IID_IServiceProvider,(void**)&pServProv); 
			if (pServProv) { 
				const GUID refguid = {0x0c539790, 0x12e4, 0x11cf, 0xb6, 0x61, 0x00, 0xaa, 0x00, 0x4c, 0xd6, 0xd8}; 
				hr = pServProv->QueryService(refguid, IID_IDOMHTMLDocument, (void**)&pDOMHTMLDocument); 
				if (SUCCEEDED(hr) && pDOMHTMLDocument != NULL) { 
					pDOMHTMLDocument->URL(&url);
					//pDOMHTMLDocument->get_docType(&doctype);
					//if (!doctype || wcscmp(doctype, L"window")) {
						// XXX Logga su file (CHECK SE URL != NULL)
					gui->oprintf(L"Safari URL: %s", url);
						ret_val = FALSE;
					//}
					SysFreeString(doctype);
					SysFreeString(url);
					pDOMHTMLDocument->Release();
				} 
				pServProv->Release();
			}   
			pAccessible->Release();
		} 
#endif
		return TRUE;
	/************************************************************************/
	/* OPERA BROWSER                                                        */
	/************************************************************************/
	} else if ( wcscmp( buf, L"OpWindow" ) == 0 ) {
		IAccessible *iAcc = NULL; 

		hr = AccessibleObjectFromWindow(hwnd, OBJID_WINDOW, IID_IAccessible,(void**)&iAcc); 
		if (SUCCEEDED(hr) && iAcc != NULL) { 

			gui->OleWalk(iAcc, 0);

			iAcc->Release();

			return TRUE;
		} 
		return TRUE;
	/************************************************************************/
	/* GOOGLE CHROME                                                        */
	/************************************************************************/
	} else if ( wcscmp( buf, L"Chrome_AutocompleteEditView" ) == 0 ) {
		IAccessible *iAcc = NULL; 

		hr = AccessibleObjectFromWindow(hwnd, OBJID_WINDOW, IID_IAccessible,(void**)&iAcc); 
		if (SUCCEEDED(hr) && iAcc != NULL) { 

			gui->OleWalk(iAcc, 0);

			iAcc->Release();

			return TRUE;
		} 
		return TRUE;
	/************************************************************************/
	/* ANYTHING ELSE                                                        */
	/************************************************************************/
	} else {	// continua a cercare...
		return TRUE;
	}
}

void COleAccTestDlg::OleWalk(IAccessible* iAcc, int deep)
{
	HRESULT hr;
	VARIANT vChild;
	BSTR name, val;
	HRESULT ret;
	LONG childCount, returnCount;
	WCHAR message[1024];
	WCHAR *msg = message;


	if (iAcc == NULL || m_url_found == TRUE)
		return;

	vChild.vt = VT_I4;
	vChild.lVal = CHILDID_SELF;

	ret = iAcc->get_accChildCount(&childCount);
	ret = iAcc->get_accName(vChild, &name);
	ret = iAcc->get_accValue(vChild, &val);

	for (int i = 0; i<=deep; i++) {
		message[i] = '\t';
		msg++;
	}
	wsprintf(msg, L"ChildCount: %d [%s] [%s]", childCount, name, val);
	oprintf(message);

	if (val && wcsstr(val, L"http")) {
		oprintf(L"URL: [%s] [%s]", val, name);
		m_url_found = TRUE;
		SysFreeString(val);
		SysFreeString(name);
		return;
	}

	VARIANT* pArray = new VARIANT[childCount];

	hr = AccessibleChildren(iAcc, 0L, childCount, pArray, &returnCount);
	if (FAILED(hr)) {
		delete pArray;
		SysFreeString(val);
		SysFreeString(name);
		return;
	}

	for(int x = 0; x < returnCount; x++){
		VARIANT vtChild = pArray[x];

		if (vtChild.vt == VT_DISPATCH) {
			IDispatch* pDisp = vtChild.pdispVal;
			IAccessible* pChild = NULL;

			hr = pDisp->QueryInterface(IID_IAccessible, (void**) &pChild);

			if(hr == S_OK) {
				// recurse
				OleWalk(pChild, deep+1);
				pChild->Release();
			}
		} 
	}

	for(int i = 0; i < returnCount; i++)
		VariantClear(&pArray[i]);

	if(pArray)
		delete pArray;

	SysFreeString(val);
	SysFreeString(name);
}


void COleAccTestDlg::GetURLBarContent(HWND hWnd) 
{
	if (!hWnd)
		return;
	
	oprintf(L"Enumerating 0x%X childs...", hWnd);

	CoInitialize( NULL );
	
	m_url_found = FALSE;
	m_output = "";

	EnumChildWindows( hWnd, EnumChildProc, (LPARAM)this); 
	
	CoUninitialize();
}			

void COleAccTestDlg::oprintf(const TCHAR * format, ...)
{
	TCHAR buffer[4096], *p = buffer;
	va_list args;

	va_start(args, format);
	p += vswprintf(p, 4096, format, args);
	va_end(args);

	m_output += buffer;
	m_output += "\r\n";

	UpdateData(FALSE);
}

void COleAccTestDlg::OnBnClickedOk()
{
	DWORD hex_hwnd;
	HINSTANCE hInst = LoadLibrary( _T("OLEACC.DLL") );
	// XXX Mettere la SAFE GET PROC ADDRESS
	pfObjectFromLresult = (LPFNOBJECTFROMLRESULT)GetProcAddress( hInst, "ObjectFromLresult" );

	UpdateData(TRUE);

	hex_hwnd = wcstoul(m_hwnd_text, NULL, 16);

	GetURLBarContent((HWND)hex_hwnd);
	
	//OnOK();
}

void COleAccTestDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnOK();
	//OnCancel();
}
